///////////////////////////////////////////////////////////
//  SU(3) matrix times SU(3)-2-spinor
///////////////////////////////////////////////////////////
static __inline__ __device__ void  
matvec2(float4 *uri, float4 *yri){
  float urx3,uix3;

// 0-2
  urx3  = __ur21(uri)*__ur32(uri);
  urx3 += __ui31(uri)*__ui22(uri);
  urx3  = -urx3;
  urx3 += __ui21(uri)*__ui32(uri);
  urx3 += __ur31(uri)*__ur22(uri);
  urx3  = -urx3;

  uix3  = __ur31(uri)*__ui22(uri);
  uix3 += __ui31(uri)*__ur22(uri);
  uix3  = -uix3;
  uix3 += __ur21(uri)*__ui32(uri);
  uix3 += __ui21(uri)*__ur32(uri);
  uix3  = -uix3;
  
  __yr13(yri) = __ur11(uri) * __yr11(yri);
  __yr13(yri)+= __ur12(uri) * __yr21(yri);
  __yr13(yri)+=   urx3      * __yr31(yri);
  __yr13(yri) = -__yr13(yri);
  __yr13(yri)+= __ui11(uri) * __yi11(yri);
  __yr13(yri)+= __ui12(uri) * __yi21(yri);
  __yr13(yri)+=   uix3      * __yi31(yri);
  __yr13(yri) = -__yr13(yri);
  __yr14(yri) = __ur11(uri) * __yr12(yri);
  __yr14(yri)+= __ur12(uri) * __yr22(yri);
  __yr14(yri)+=   urx3      * __yr32(yri);
  __yr14(yri) = -__yr14(yri);
  __yr14(yri)+= __ui11(uri) * __yi12(yri);
  __yr14(yri)+= __ui12(uri) * __yi22(yri);
  __yr14(yri)+=   uix3      * __yi32(yri);
  __yr14(yri) = -__yr14(yri);
  __yi13(yri) = __ur11(uri) * __yi11(yri);
  __yi13(yri)+= __ur12(uri) * __yi21(yri);
  __yi13(yri)+=   urx3      * __yi31(yri);
  __yi13(yri)+= __ui11(uri) * __yr11(yri);
  __yi13(yri)+= __ui12(uri) * __yr21(yri);
  __yi13(yri)+=   uix3      * __yr31(yri);
  __yi14(yri) = __ur11(uri) * __yi12(yri);
  __yi14(yri)+= __ur12(uri) * __yi22(yri);
  __yi14(yri)+=   urx3      * __yi32(yri);
  __yi14(yri)+= __ui11(uri) * __yr12(yri);
  __yi14(yri)+= __ui12(uri) * __yr22(yri);
  __yi14(yri)+=   uix3      * __yr32(yri);

// 1-2
  urx3  = __ur31(uri)*__ur12(uri);
  urx3 += __ui11(uri)*__ui32(uri);
  urx3  = -urx3;
  urx3 += __ui31(uri)*__ui12(uri);
  urx3 += __ur11(uri)*__ur32(uri);
  urx3  = -urx3;

  uix3  = __ur11(uri)*__ui32(uri);
  uix3 += __ui11(uri)*__ur32(uri);
  uix3  = -uix3;
  uix3 += __ur31(uri)*__ui12(uri);
  uix3 += __ui31(uri)*__ur12(uri);
  uix3  = -uix3;

  __yr23(yri) = __ur21(uri) * __yr11(yri);
  __yr23(yri)+= __ur22(uri) * __yr21(yri);
  __yr23(yri)+=   urx3      * __yr31(yri);
  __yr23(yri) = -__yr23(yri);
  __yr23(yri)+= __ui21(uri) * __yi11(yri);
  __yr23(yri)+= __ui22(uri) * __yi21(yri);
  __yr23(yri)+=   uix3      * __yi31(yri);
  __yr23(yri) = -__yr23(yri);
  __yr24(yri) = __ur21(uri) * __yr12(yri);
  __yr24(yri)+= __ur22(uri) * __yr22(yri);
  __yr24(yri)+=   urx3      * __yr32(yri);
  __yr24(yri) = -__yr24(yri);
  __yr24(yri)+= __ui21(uri) * __yi12(yri);
  __yr24(yri)+= __ui22(uri) * __yi22(yri);
  __yr24(yri)+=   uix3      * __yi32(yri);
  __yr24(yri) = -__yr24(yri);
  __yi23(yri) = __ur21(uri) * __yi11(yri);
  __yi23(yri)+= __ur22(uri) * __yi21(yri);
  __yi23(yri)+=   urx3      * __yi31(yri);
  __yi23(yri)+= __ui21(uri) * __yr11(yri);
  __yi23(yri)+= __ui22(uri) * __yr21(yri);
  __yi23(yri)+=   uix3      * __yr31(yri);
  __yi24(yri) = __ur21(uri) * __yi12(yri);
  __yi24(yri)+= __ur22(uri) * __yi22(yri);
  __yi24(yri)+=   urx3      * __yi32(yri);
  __yi24(yri)+= __ui21(uri) * __yr12(yri);
  __yi24(yri)+= __ui22(uri) * __yr22(yri);
  __yi24(yri)+=   uix3      * __yr32(yri);

// 2-2
  urx3  = __ur11(uri)*__ur22(uri);
  urx3 += __ui21(uri)*__ui12(uri);
  urx3  = -urx3;
  urx3 += __ui11(uri)*__ui22(uri);
  urx3 += __ur21(uri)*__ur12(uri);
  urx3  = -urx3;

  uix3  = __ur21(uri)*__ui12(uri);
  uix3 += __ui21(uri)*__ur12(uri);
  uix3  = -uix3;
  uix3 += __ur11(uri)*__ui22(uri);
  uix3 += __ui11(uri)*__ur22(uri);
  uix3  = -uix3;

  __yr33(yri) = __ur31(uri) * __yr11(yri);
  __yr33(yri)+= __ur32(uri) * __yr21(yri);
  __yr33(yri)+=   urx3      * __yr31(yri);
  __yr33(yri) = -__yr33(yri);
  __yr33(yri)+= __ui31(uri) * __yi11(yri);
  __yr33(yri)+= __ui32(uri) * __yi21(yri);
  __yr33(yri)+=   uix3      * __yi31(yri);
  __yr33(yri) = -__yr33(yri);
  __yr34(yri) = __ur31(uri) * __yr12(yri);
  __yr34(yri)+= __ur32(uri) * __yr22(yri);
  __yr34(yri)+=   urx3      * __yr32(yri);
  __yr34(yri) = -__yr34(yri);
  __yr34(yri)+= __ui31(uri) * __yi12(yri);
  __yr34(yri)+= __ui32(uri) * __yi22(yri);
  __yr34(yri)+=   uix3      * __yi32(yri);
  __yr34(yri) = -__yr34(yri);
  __yi33(yri) = __ur31(uri) * __yi11(yri);
  __yi33(yri)+= __ur32(uri) * __yi21(yri);
  __yi33(yri)+=   urx3      * __yi31(yri);
  __yi33(yri)+= __ui31(uri) * __yr11(yri);
  __yi33(yri)+= __ui32(uri) * __yr21(yri);
  __yi33(yri)+=   uix3      * __yr31(yri);
  __yi34(yri) = __ur31(uri) * __yi12(yri);
  __yi34(yri)+= __ur32(uri) * __yi22(yri);
  __yi34(yri)+=   urx3      * __yi32(yri);
  __yi34(yri)+= __ui31(uri) * __yr12(yri);
  __yi34(yri)+= __ui32(uri) * __yr22(yri);
  __yi34(yri)+=   uix3      * __yr32(yri);

}

///////////////////////////////////////////////////////////
// SU(3) matrix-dagger times SU(3)-2-spinor
///////////////////////////////////////////////////////////
static __inline__ __device__ void 
matdagvec2(float4 *uri, float4 *yri){

  __yr13(yri) = __ur11(uri) * __yr11(yri)
              + __ur21(uri) * __yr21(yri)
              + __ur31(uri) * __yr31(yri)
              + __ui11(uri) * __yi11(yri)
              + __ui21(uri) * __yi21(yri)
              + __ui31(uri) * __yi31(yri);
  __yr14(yri) = __ur11(uri) * __yr12(yri)
              + __ur21(uri) * __yr22(yri)
              + __ur31(uri) * __yr32(yri)
              + __ui11(uri) * __yi12(yri)
              + __ui21(uri) * __yi22(yri)
              + __ui31(uri) * __yi32(yri);
  __yi13(yri) = __ur11(uri) * __yi11(yri)
              + __ur21(uri) * __yi21(yri)
              + __ur31(uri) * __yi31(yri);
  __yi13(yri) = -__yi13(yri);
  __yi13(yri)+= __ui11(uri) * __yr11(yri)
              + __ui21(uri) * __yr21(yri)
              + __ui31(uri) * __yr31(yri);
  __yi13(yri) = -__yi13(yri);
  __yi14(yri) = __ur11(uri) * __yi12(yri)
              + __ur21(uri) * __yi22(yri)
              + __ur31(uri) * __yi32(yri);
  __yi14(yri) = -__yi14(yri);
  __yi14(yri)+= __ui11(uri) * __yr12(yri)
              + __ui21(uri) * __yr22(yri)
              + __ui31(uri) * __yr32(yri);
  __yi14(yri) = -__yi14(yri);

  __yr23(yri) = __ur12(uri) * __yr11(yri)
              + __ur22(uri) * __yr21(yri)
              + __ur32(uri) * __yr31(yri)
              + __ui12(uri) * __yi11(yri)
              + __ui22(uri) * __yi21(yri)
              + __ui32(uri) * __yi31(yri);
  __yr24(yri) = __ur12(uri) * __yr12(yri)
              + __ur22(uri) * __yr22(yri)
              + __ur32(uri) * __yr32(yri)
              + __ui12(uri) * __yi12(yri)
              + __ui22(uri) * __yi22(yri)
              + __ui32(uri) * __yi32(yri);
  __yi23(yri) = __ur12(uri) * __yi11(yri)
              + __ur22(uri) * __yi21(yri)
              + __ur32(uri) * __yi31(yri);
  __yi23(yri) = -__yi23(yri);
  __yi23(yri)+= __ui12(uri) * __yr11(yri)
              + __ui22(uri) * __yr21(yri)
              + __ui32(uri) * __yr31(yri);
  __yi23(yri) = -__yi23(yri);
  __yi24(yri) = __ur12(uri) * __yi12(yri)
              + __ur22(uri) * __yi22(yri)
              + __ur32(uri) * __yi32(yri);
  __yi24(yri) = -__yi24(yri);
  __yi24(yri)+= __ui12(uri) * __yr12(yri)
              + __ui22(uri) * __yr22(yri)
              + __ui32(uri) * __yr32(yri);
  __yi24(yri) = -__yi24(yri);


// 0-2
  float ux3r,ux3i;
  ux3r  = __ur21(uri)*__ur32(uri) + __ui31(uri)*__ui22(uri);
  ux3i  = __ur31(uri)*__ui22(uri) + __ui31(uri)*__ur22(uri);
  ux3r  = -ux3r;
  ux3i  = -ux3i;
  ux3r += __ui21(uri)*__ui32(uri) + __ur31(uri)*__ur22(uri);
  ux3i += __ur21(uri)*__ui32(uri) + __ui21(uri)*__ur32(uri);
  ux3r  = -ux3r;
  ux3i  = -ux3i;

  __yr33(yri) = ux3r * __yr11(yri);
  __yr34(yri) = ux3r * __yr12(yri);
  __yi33(yri) = ux3r * __yi11(yri);
  __yi34(yri) = ux3r * __yi12(yri);
  __yr33(yri)+= ux3i * __yi11(yri);
  __yr34(yri)+= ux3i * __yi12(yri);
  ux3i        = -ux3i;
  __yi33(yri)+= ux3i * __yr11(yri);
  __yi34(yri)+= ux3i * __yr12(yri);

// 1-2
  ux3r  = __ur31(uri)*__ur12(uri) + __ui11(uri)*__ui32(uri);
  ux3i  = __ur11(uri)*__ui32(uri) + __ui11(uri)*__ur32(uri);
  ux3r  = -ux3r;
  ux3i  = -ux3i;
  ux3r += __ui31(uri)*__ui12(uri) + __ur11(uri)*__ur32(uri);
  ux3i += __ur31(uri)*__ui12(uri) + __ui31(uri)*__ur12(uri);
  ux3r  = -ux3r;
  ux3i  = -ux3i;

  __yr33(yri)+= ux3r * __yr21(yri);
  __yr34(yri)+= ux3r * __yr22(yri);
  __yi33(yri)+= ux3r * __yi21(yri);
  __yi34(yri)+= ux3r * __yi22(yri);
  __yr33(yri)+= ux3i * __yi21(yri);
  __yr34(yri)+= ux3i * __yi22(yri);
  ux3i        = -ux3i;
  __yi33(yri)+= ux3i * __yr21(yri);
  __yi34(yri)+= ux3i * __yr22(yri);

// 2-2
  ux3r  = __ur11(uri)*__ur22(uri) + __ui21(uri)*__ui12(uri);
  ux3i  = __ur21(uri)*__ui12(uri) + __ui21(uri)*__ur12(uri);
  ux3r  = -ux3r;
  ux3i  = -ux3i;
  ux3r += __ui11(uri)*__ui22(uri) + __ur21(uri)*__ur12(uri);
  ux3i += __ur11(uri)*__ui22(uri) + __ui11(uri)*__ur22(uri);
  ux3r  = -ux3r;
  ux3i  = -ux3i;

  __yr33(yri)+= ux3r * __yr31(yri);
  __yr34(yri)+= ux3r * __yr32(yri);
  __yi33(yri)+= ux3r * __yi31(yri);
  __yi34(yri)+= ux3r * __yi32(yri);
  __yr33(yri)+= ux3i * __yi31(yri);
  __yr34(yri)+= ux3i * __yi32(yri);
  ux3i        = -ux3i;
  __yi33(yri)+= ux3i * __yr31(yri);
  __yi34(yri)+= ux3i * __yr32(yri);
}

///////////////////////////////////////////////////////////
// 6x6 Hermitian matrix times SU(3)-2-spinor
// (ar,ai) = F1 * (pr,pi)
///////////////////////////////////////////////////////////
static __inline__ __device__ void 
clvvec1(const cu_clvf_eo_thd *fri, const int *ith, const float *pr, const float *pi, float *ar, float *ai){
//  a = f * p
  ar[0] =  __f1r0(fri,*ith) * pr[0]
         + __f1r1(fri,*ith) * pr[1] - __f1i1(fri,*ith) * pi[1]
         + __f1r2(fri,*ith) * pr[2] - __f1i2(fri,*ith) * pi[2]
         + __f1r3(fri,*ith) * pr[3] - __f1i3(fri,*ith) * pi[3]
         + __f1r4(fri,*ith) * pr[4] - __f1i4(fri,*ith) * pi[4]
         + __f1r5(fri,*ith) * pr[5] - __f1i5(fri,*ith) * pi[5];
  ai[0] =  __f1r0(fri,*ith) * pi[0]
         + __f1r1(fri,*ith) * pi[1] + __f1i1(fri,*ith) * pr[1]
         + __f1r2(fri,*ith) * pi[2] + __f1i2(fri,*ith) * pr[2]
         + __f1r3(fri,*ith) * pi[3] + __f1i3(fri,*ith) * pr[3]
         + __f1r4(fri,*ith) * pi[4] + __f1i4(fri,*ith) * pr[4]
         + __f1r5(fri,*ith) * pi[5] + __f1i5(fri,*ith) * pr[5];
  ar[1] =  __f1r1(fri,*ith) * pr[0] + __f1i1(fri,*ith) * pi[0];
  ai[1] =  __f1r1(fri,*ith) * pi[0] - __f1i1(fri,*ith) * pr[0];
  ar[2] =  __f1r2(fri,*ith) * pr[0] + __f1i2(fri,*ith) * pi[0];
  ai[2] =  __f1r2(fri,*ith) * pi[0] - __f1i2(fri,*ith) * pr[0];
  ar[3] =  __f1r3(fri,*ith) * pr[0] + __f1i3(fri,*ith) * pi[0];
  ai[3] =  __f1r3(fri,*ith) * pi[0] - __f1i3(fri,*ith) * pr[0];
  ar[4] =  __f1r4(fri,*ith) * pr[0] + __f1i4(fri,*ith) * pi[0];
  ai[4] =  __f1r4(fri,*ith) * pi[0] - __f1i4(fri,*ith) * pr[0];
  ar[5] =  __f1r5(fri,*ith) * pr[0] + __f1i5(fri,*ith) * pi[0];
  ai[5] =  __f1r5(fri,*ith) * pi[0] - __f1i5(fri,*ith) * pr[0];

  ar[1] += __f1r6(fri,*ith) * pr[1]
         + __f1r7(fri,*ith) * pr[2] - __f1i7(fri,*ith) * pi[2]
         + __f1r8(fri,*ith) * pr[3] - __f1i8(fri,*ith) * pi[3]
         + __f1r9(fri,*ith) * pr[4] - __f1i9(fri,*ith) * pi[4]
         + __f1r10(fri,*ith)* pr[5] - __f1i10(fri,*ith)* pi[5];
  ai[1] += __f1r6(fri,*ith) * pi[1]
         + __f1r7(fri,*ith) * pi[2] + __f1i7(fri,*ith) * pr[2]
         + __f1r8(fri,*ith) * pi[3] + __f1i8(fri,*ith) * pr[3]
         + __f1r9(fri,*ith) * pi[4] + __f1i9(fri,*ith) * pr[4]
         + __f1r10(fri,*ith)* pi[5] + __f1i10(fri,*ith)* pr[5];
  ar[2] += __f1r7(fri,*ith) * pr[1] + __f1i7(fri,*ith) * pi[1];
  ai[2] += __f1r7(fri,*ith) * pi[1] - __f1i7(fri,*ith) * pr[1];
  ar[3] += __f1r8(fri,*ith) * pr[1] + __f1i8(fri,*ith) * pi[1];
  ai[3] += __f1r8(fri,*ith) * pi[1] - __f1i8(fri,*ith) * pr[1];
  ar[4] += __f1r9(fri,*ith) * pr[1] + __f1i9(fri,*ith) * pi[1];
  ai[4] += __f1r9(fri,*ith) * pi[1] - __f1i9(fri,*ith) * pr[1];
  ar[5] += __f1r10(fri,*ith)* pr[1] + __f1i10(fri,*ith)* pi[1];
  ai[5] += __f1r10(fri,*ith)* pi[1] - __f1i10(fri,*ith)* pr[1];
           
  ar[2] += __f1r11(fri,*ith)* pr[2]
         + __f1r12(fri,*ith)* pr[3] - __f1i12(fri,*ith)* pi[3]
         + __f1r13(fri,*ith)* pr[4] - __f1i13(fri,*ith)* pi[4]
         + __f1r14(fri,*ith)* pr[5] - __f1i14(fri,*ith)* pi[5];
  ai[2] += __f1r11(fri,*ith)* pi[2]
         + __f1r12(fri,*ith)* pi[3] + __f1i12(fri,*ith)* pr[3]
         + __f1r13(fri,*ith)* pi[4] + __f1i13(fri,*ith)* pr[4]
         + __f1r14(fri,*ith)* pi[5] + __f1i14(fri,*ith)* pr[5];
  ar[3] += __f1r12(fri,*ith)* pr[2] + __f1i12(fri,*ith)* pi[2];
  ai[3] += __f1r12(fri,*ith)* pi[2] - __f1i12(fri,*ith)* pr[2];
  ar[4] += __f1r13(fri,*ith)* pr[2] + __f1i13(fri,*ith)* pi[2];
  ai[4] += __f1r13(fri,*ith)* pi[2] - __f1i13(fri,*ith)* pr[2];
  ar[5] += __f1r14(fri,*ith)* pr[2] + __f1i14(fri,*ith)* pi[2];
  ai[5] += __f1r14(fri,*ith)* pi[2] - __f1i14(fri,*ith)* pr[2];
           
  ar[3] += __f1r15(fri,*ith)* pr[3]
         + __f1r16(fri,*ith)* pr[4] - __f1i16(fri,*ith)* pi[4]
         + __f1r17(fri,*ith)* pr[5] - __f1i17(fri,*ith)* pi[5];
  ai[3] += __f1r15(fri,*ith)* pi[3]
         + __f1r16(fri,*ith)* pi[4] + __f1i16(fri,*ith)* pr[4]
         + __f1r17(fri,*ith)* pi[5] + __f1i17(fri,*ith)* pr[5];
  ar[4] += __f1r16(fri,*ith)* pr[3] + __f1i16(fri,*ith)* pi[3];
  ai[4] += __f1r16(fri,*ith)* pi[3] - __f1i16(fri,*ith)* pr[3];
  ar[5] += __f1r17(fri,*ith)* pr[3] + __f1i17(fri,*ith)* pi[3];
  ai[5] += __f1r17(fri,*ith)* pi[3] - __f1i17(fri,*ith)* pr[3];
           
  ar[4] += __f1r18(fri,*ith)* pr[4]
         + __f1r19(fri,*ith)* pr[5] - __f1i19(fri,*ith)* pi[5];
  ai[4] += __f1r18(fri,*ith)* pi[4]
         + __f1r19(fri,*ith)* pi[5] + __f1i19(fri,*ith)* pr[5];
  ar[5] += __f1r19(fri,*ith)* pr[4] + __f1i19(fri,*ith)* pi[4]
         + __f1r20(fri,*ith)* pr[5];
  ai[5] += __f1r19(fri,*ith)* pi[4] - __f1i19(fri,*ith)* pr[4]
         + __f1r20(fri,*ith)* pi[5];
}

///////////////////////////////////////////////////////////
// 6x6 Hermitian matrix times SU(3)-2-spinor
// (ar,ai) = F2 * (pr,pi)
///////////////////////////////////////////////////////////
static __inline__ __device__ void 
clvvec2(const cu_clvf_eo_thd *fri, const int *ith, const float *pr, const float *pi, float *ar, float *ai){
//  a = f * p
  ar[0] =  __f2r0(fri,*ith) * pr[0]
         + __f2r1(fri,*ith) * pr[1] - __f2i1(fri,*ith) * pi[1]
         + __f2r2(fri,*ith) * pr[2] - __f2i2(fri,*ith) * pi[2]
         + __f2r3(fri,*ith) * pr[3] - __f2i3(fri,*ith) * pi[3]
         + __f2r4(fri,*ith) * pr[4] - __f2i4(fri,*ith) * pi[4]
         + __f2r5(fri,*ith) * pr[5] - __f2i5(fri,*ith) * pi[5];
  ai[0] =  __f2r0(fri,*ith) * pi[0]
         + __f2r1(fri,*ith) * pi[1] + __f2i1(fri,*ith) * pr[1]
         + __f2r2(fri,*ith) * pi[2] + __f2i2(fri,*ith) * pr[2]
         + __f2r3(fri,*ith) * pi[3] + __f2i3(fri,*ith) * pr[3]
         + __f2r4(fri,*ith) * pi[4] + __f2i4(fri,*ith) * pr[4]
         + __f2r5(fri,*ith) * pi[5] + __f2i5(fri,*ith) * pr[5];
  ar[1] =  __f2r1(fri,*ith) * pr[0] + __f2i1(fri,*ith) * pi[0];
  ai[1] =  __f2r1(fri,*ith) * pi[0] - __f2i1(fri,*ith) * pr[0];
  ar[2] =  __f2r2(fri,*ith) * pr[0] + __f2i2(fri,*ith) * pi[0];
  ai[2] =  __f2r2(fri,*ith) * pi[0] - __f2i2(fri,*ith) * pr[0];
  ar[3] =  __f2r3(fri,*ith) * pr[0] + __f2i3(fri,*ith) * pi[0];
  ai[3] =  __f2r3(fri,*ith) * pi[0] - __f2i3(fri,*ith) * pr[0];
  ar[4] =  __f2r4(fri,*ith) * pr[0] + __f2i4(fri,*ith) * pi[0];
  ai[4] =  __f2r4(fri,*ith) * pi[0] - __f2i4(fri,*ith) * pr[0];
  ar[5] =  __f2r5(fri,*ith) * pr[0] + __f2i5(fri,*ith) * pi[0];
  ai[5] =  __f2r5(fri,*ith) * pi[0] - __f2i5(fri,*ith) * pr[0];

  ar[1] += __f2r6(fri,*ith) * pr[1]
         + __f2r7(fri,*ith) * pr[2] - __f2i7(fri,*ith) * pi[2]
         + __f2r8(fri,*ith) * pr[3] - __f2i8(fri,*ith) * pi[3]
         + __f2r9(fri,*ith) * pr[4] - __f2i9(fri,*ith) * pi[4]
         + __f2r10(fri,*ith)* pr[5] - __f2i10(fri,*ith)* pi[5];
  ai[1] += __f2r6(fri,*ith) * pi[1]
         + __f2r7(fri,*ith) * pi[2] + __f2i7(fri,*ith) * pr[2]
         + __f2r8(fri,*ith) * pi[3] + __f2i8(fri,*ith) * pr[3]
         + __f2r9(fri,*ith) * pi[4] + __f2i9(fri,*ith) * pr[4]
         + __f2r10(fri,*ith)* pi[5] + __f2i10(fri,*ith)* pr[5];
  ar[2] += __f2r7(fri,*ith) * pr[1] + __f2i7(fri,*ith) * pi[1];
  ai[2] += __f2r7(fri,*ith) * pi[1] - __f2i7(fri,*ith) * pr[1];
  ar[3] += __f2r8(fri,*ith) * pr[1] + __f2i8(fri,*ith) * pi[1];
  ai[3] += __f2r8(fri,*ith) * pi[1] - __f2i8(fri,*ith) * pr[1];
  ar[4] += __f2r9(fri,*ith) * pr[1] + __f2i9(fri,*ith) * pi[1];
  ai[4] += __f2r9(fri,*ith) * pi[1] - __f2i9(fri,*ith) * pr[1];
  ar[5] += __f2r10(fri,*ith)* pr[1] + __f2i10(fri,*ith)* pi[1];
  ai[5] += __f2r10(fri,*ith)* pi[1] - __f2i10(fri,*ith)* pr[1];
           
  ar[2] += __f2r11(fri,*ith)* pr[2]
         + __f2r12(fri,*ith)* pr[3] - __f2i12(fri,*ith)* pi[3]
         + __f2r13(fri,*ith)* pr[4] - __f2i13(fri,*ith)* pi[4]
         + __f2r14(fri,*ith)* pr[5] - __f2i14(fri,*ith)* pi[5];
  ai[2] += __f2r11(fri,*ith)* pi[2]
         + __f2r12(fri,*ith)* pi[3] + __f2i12(fri,*ith)* pr[3]
         + __f2r13(fri,*ith)* pi[4] + __f2i13(fri,*ith)* pr[4]
         + __f2r14(fri,*ith)* pi[5] + __f2i14(fri,*ith)* pr[5];
  ar[3] += __f2r12(fri,*ith)* pr[2] + __f2i12(fri,*ith)* pi[2];
  ai[3] += __f2r12(fri,*ith)* pi[2] - __f2i12(fri,*ith)* pr[2];
  ar[4] += __f2r13(fri,*ith)* pr[2] + __f2i13(fri,*ith)* pi[2];
  ai[4] += __f2r13(fri,*ith)* pi[2] - __f2i13(fri,*ith)* pr[2];
  ar[5] += __f2r14(fri,*ith)* pr[2] + __f2i14(fri,*ith)* pi[2];
  ai[5] += __f2r14(fri,*ith)* pi[2] - __f2i14(fri,*ith)* pr[2];
           
  ar[3] += __f2r15(fri,*ith)* pr[3]
         + __f2r16(fri,*ith)* pr[4] - __f2i16(fri,*ith)* pi[4]
         + __f2r17(fri,*ith)* pr[5] - __f2i17(fri,*ith)* pi[5];
  ai[3] += __f2r15(fri,*ith)* pi[3]
         + __f2r16(fri,*ith)* pi[4] + __f2i16(fri,*ith)* pr[4]
         + __f2r17(fri,*ith)* pi[5] + __f2i17(fri,*ith)* pr[5];
  ar[4] += __f2r16(fri,*ith)* pr[3] + __f2i16(fri,*ith)* pi[3];
  ai[4] += __f2r16(fri,*ith)* pi[3] - __f2i16(fri,*ith)* pr[3];
  ar[5] += __f2r17(fri,*ith)* pr[3] + __f2i17(fri,*ith)* pi[3];
  ai[5] += __f2r17(fri,*ith)* pi[3] - __f2i17(fri,*ith)* pr[3];
           
  ar[4] += __f2r18(fri,*ith)* pr[4]
         + __f2r19(fri,*ith)* pr[5] - __f2i19(fri,*ith)* pi[5];
  ai[4] += __f2r18(fri,*ith)* pi[4]
         + __f2r19(fri,*ith)* pi[5] + __f2i19(fri,*ith)* pr[5];
  ar[5] += __f2r19(fri,*ith)* pr[4] + __f2i19(fri,*ith)* pi[4]
         + __f2r20(fri,*ith)* pr[5];
  ai[5] += __f2r19(fri,*ith)* pi[4] - __f2i19(fri,*ith)* pr[4]
         + __f2r20(fri,*ith)* pi[5];
}
