module pfcoef_inv_qdrt_class
  use pfcoef_param_class
  implicit none
  private
  public :: partial_fraction_coef
  public :: get_pfcoef_inv_qdrt
  real(DP), save :: minimaxerror(nkey)
  real(DP), save :: alp(nkey,0:npmax)
  real(DP), save :: bet(nkey,1:npmax)
  logical,  save :: m_is_initialized = .false.

contains

subroutine get_pfcoef_inv_qdrt(this,m,mpow)
  implicit none
  type(partial_fraction_coef), intent(inout) :: this
  integer, intent(in) :: m
  integer, intent(in) :: mpow
  integer :: ikey
  call new_pfcoef_inv_qdrt
  if (allocated(this%alp)) deallocate(this%alp)
  if (allocated(this%bet)) deallocate(this%bet)
  allocate(this%alp(0:m))
  allocate(this%bet(1:m))
  ikey = mpow + (m-npmin)*npowmax
  this%npow = mpow
  this%n    = m
  this%minimaxerror = minimaxerror(ikey)
  this%alp(0:m) = alp(ikey,0:m)
  this%bet(1:m) = bet(ikey,1:m)
  return
end subroutine

subroutine new_pfcoef_inv_qdrt()
  implicit none
  integer :: ikey,np,npow
  if (m_is_initialized) return
#include "PFcoef_InvQuadRootN04E01.dat"
#include "PFcoef_InvQuadRootN04E02.dat"
#include "PFcoef_InvQuadRootN04E03.dat"
#include "PFcoef_InvQuadRootN04E04.dat"
#include "PFcoef_InvQuadRootN04E05.dat"
#include "PFcoef_InvQuadRootN04E06.dat"
#include "PFcoef_InvQuadRootN04E07.dat"
#include "PFcoef_InvQuadRootN04E08.dat"
#include "PFcoef_InvQuadRootN05E01.dat"
#include "PFcoef_InvQuadRootN05E02.dat"
#include "PFcoef_InvQuadRootN05E03.dat"
#include "PFcoef_InvQuadRootN05E04.dat"
#include "PFcoef_InvQuadRootN05E05.dat"
#include "PFcoef_InvQuadRootN05E06.dat"
#include "PFcoef_InvQuadRootN05E07.dat"
#include "PFcoef_InvQuadRootN05E08.dat"
#include "PFcoef_InvQuadRootN06E01.dat"
#include "PFcoef_InvQuadRootN06E02.dat"
#include "PFcoef_InvQuadRootN06E03.dat"
#include "PFcoef_InvQuadRootN06E04.dat"
#include "PFcoef_InvQuadRootN06E05.dat"
#include "PFcoef_InvQuadRootN06E06.dat"
#include "PFcoef_InvQuadRootN06E07.dat"
#include "PFcoef_InvQuadRootN06E08.dat"
#include "PFcoef_InvQuadRootN07E01.dat"
#include "PFcoef_InvQuadRootN07E02.dat"
#include "PFcoef_InvQuadRootN07E03.dat"
#include "PFcoef_InvQuadRootN07E04.dat"
#include "PFcoef_InvQuadRootN07E05.dat"
#include "PFcoef_InvQuadRootN07E06.dat"
#include "PFcoef_InvQuadRootN07E07.dat"
#include "PFcoef_InvQuadRootN07E08.dat"
#include "PFcoef_InvQuadRootN08E01.dat"
#include "PFcoef_InvQuadRootN08E02.dat"
#include "PFcoef_InvQuadRootN08E03.dat"
#include "PFcoef_InvQuadRootN08E04.dat"
#include "PFcoef_InvQuadRootN08E05.dat"
#include "PFcoef_InvQuadRootN08E06.dat"
#include "PFcoef_InvQuadRootN08E07.dat"
#include "PFcoef_InvQuadRootN08E08.dat"
#include "PFcoef_InvQuadRootN09E01.dat"
#include "PFcoef_InvQuadRootN09E02.dat"
#include "PFcoef_InvQuadRootN09E03.dat"
#include "PFcoef_InvQuadRootN09E04.dat"
#include "PFcoef_InvQuadRootN09E05.dat"
#include "PFcoef_InvQuadRootN09E06.dat"
#include "PFcoef_InvQuadRootN09E07.dat"
#include "PFcoef_InvQuadRootN09E08.dat"
#include "PFcoef_InvQuadRootN10E01.dat"
#include "PFcoef_InvQuadRootN10E02.dat"
#include "PFcoef_InvQuadRootN10E03.dat"
#include "PFcoef_InvQuadRootN10E04.dat"
#include "PFcoef_InvQuadRootN10E05.dat"
#include "PFcoef_InvQuadRootN10E06.dat"
#include "PFcoef_InvQuadRootN10E07.dat"
#include "PFcoef_InvQuadRootN10E08.dat"
#include "PFcoef_InvQuadRootN11E01.dat"
#include "PFcoef_InvQuadRootN11E02.dat"
#include "PFcoef_InvQuadRootN11E03.dat"
#include "PFcoef_InvQuadRootN11E04.dat"
#include "PFcoef_InvQuadRootN11E05.dat"
#include "PFcoef_InvQuadRootN11E06.dat"
#include "PFcoef_InvQuadRootN11E07.dat"
#include "PFcoef_InvQuadRootN11E08.dat"
#include "PFcoef_InvQuadRootN12E01.dat"
#include "PFcoef_InvQuadRootN12E02.dat"
#include "PFcoef_InvQuadRootN12E03.dat"
#include "PFcoef_InvQuadRootN12E04.dat"
#include "PFcoef_InvQuadRootN12E05.dat"
#include "PFcoef_InvQuadRootN12E06.dat"
#include "PFcoef_InvQuadRootN12E07.dat"
#include "PFcoef_InvQuadRootN12E08.dat"
#include "PFcoef_InvQuadRootN13E01.dat"
#include "PFcoef_InvQuadRootN13E02.dat"
#include "PFcoef_InvQuadRootN13E03.dat"
#include "PFcoef_InvQuadRootN13E04.dat"
#include "PFcoef_InvQuadRootN13E05.dat"
#include "PFcoef_InvQuadRootN13E06.dat"
#include "PFcoef_InvQuadRootN13E07.dat"
#include "PFcoef_InvQuadRootN13E08.dat"
#include "PFcoef_InvQuadRootN14E01.dat"
#include "PFcoef_InvQuadRootN14E02.dat"
#include "PFcoef_InvQuadRootN14E03.dat"
#include "PFcoef_InvQuadRootN14E04.dat"
#include "PFcoef_InvQuadRootN14E05.dat"
#include "PFcoef_InvQuadRootN14E06.dat"
#include "PFcoef_InvQuadRootN14E07.dat"
#include "PFcoef_InvQuadRootN14E08.dat"
#include "PFcoef_InvQuadRootN15E01.dat"
#include "PFcoef_InvQuadRootN15E02.dat"
#include "PFcoef_InvQuadRootN15E03.dat"
#include "PFcoef_InvQuadRootN15E04.dat"
#include "PFcoef_InvQuadRootN15E05.dat"
#include "PFcoef_InvQuadRootN15E06.dat"
#include "PFcoef_InvQuadRootN15E07.dat"
#include "PFcoef_InvQuadRootN15E08.dat"
#include "PFcoef_InvQuadRootN16E01.dat"
#include "PFcoef_InvQuadRootN16E02.dat"
#include "PFcoef_InvQuadRootN16E03.dat"
#include "PFcoef_InvQuadRootN16E04.dat"
#include "PFcoef_InvQuadRootN16E05.dat"
#include "PFcoef_InvQuadRootN16E06.dat"
#include "PFcoef_InvQuadRootN16E07.dat"
#include "PFcoef_InvQuadRootN16E08.dat"
#include "PFcoef_InvQuadRootN17E01.dat"
#include "PFcoef_InvQuadRootN17E02.dat"
#include "PFcoef_InvQuadRootN17E03.dat"
#include "PFcoef_InvQuadRootN17E04.dat"
#include "PFcoef_InvQuadRootN17E05.dat"
#include "PFcoef_InvQuadRootN17E06.dat"
#include "PFcoef_InvQuadRootN17E07.dat"
#include "PFcoef_InvQuadRootN17E08.dat"
#include "PFcoef_InvQuadRootN18E01.dat"
#include "PFcoef_InvQuadRootN18E02.dat"
#include "PFcoef_InvQuadRootN18E03.dat"
#include "PFcoef_InvQuadRootN18E04.dat"
#include "PFcoef_InvQuadRootN18E05.dat"
#include "PFcoef_InvQuadRootN18E06.dat"
#include "PFcoef_InvQuadRootN18E07.dat"
#include "PFcoef_InvQuadRootN18E08.dat"
#include "PFcoef_InvQuadRootN19E01.dat"
#include "PFcoef_InvQuadRootN19E02.dat"
#include "PFcoef_InvQuadRootN19E03.dat"
#include "PFcoef_InvQuadRootN19E04.dat"
#include "PFcoef_InvQuadRootN19E05.dat"
#include "PFcoef_InvQuadRootN19E06.dat"
#include "PFcoef_InvQuadRootN19E07.dat"
#include "PFcoef_InvQuadRootN19E08.dat"
#include "PFcoef_InvQuadRootN20E01.dat"
#include "PFcoef_InvQuadRootN20E02.dat"
#include "PFcoef_InvQuadRootN20E03.dat"
#include "PFcoef_InvQuadRootN20E04.dat"
#include "PFcoef_InvQuadRootN20E05.dat"
#include "PFcoef_InvQuadRootN20E06.dat"
#include "PFcoef_InvQuadRootN20E07.dat"
#include "PFcoef_InvQuadRootN20E08.dat"
#include "PFcoef_InvQuadRootN21E01.dat"
#include "PFcoef_InvQuadRootN21E02.dat"
#include "PFcoef_InvQuadRootN21E03.dat"
#include "PFcoef_InvQuadRootN21E04.dat"
#include "PFcoef_InvQuadRootN21E05.dat"
#include "PFcoef_InvQuadRootN21E06.dat"
#include "PFcoef_InvQuadRootN21E07.dat"
#include "PFcoef_InvQuadRootN21E08.dat"
#include "PFcoef_InvQuadRootN22E01.dat"
#include "PFcoef_InvQuadRootN22E02.dat"
#include "PFcoef_InvQuadRootN22E03.dat"
#include "PFcoef_InvQuadRootN22E04.dat"
#include "PFcoef_InvQuadRootN22E05.dat"
#include "PFcoef_InvQuadRootN22E06.dat"
#include "PFcoef_InvQuadRootN22E07.dat"
#include "PFcoef_InvQuadRootN22E08.dat"
#include "PFcoef_InvQuadRootN23E01.dat"
#include "PFcoef_InvQuadRootN23E02.dat"
#include "PFcoef_InvQuadRootN23E03.dat"
#include "PFcoef_InvQuadRootN23E04.dat"
#include "PFcoef_InvQuadRootN23E05.dat"
#include "PFcoef_InvQuadRootN23E06.dat"
#include "PFcoef_InvQuadRootN23E07.dat"
#include "PFcoef_InvQuadRootN23E08.dat"
#include "PFcoef_InvQuadRootN24E01.dat"
#include "PFcoef_InvQuadRootN24E02.dat"
#include "PFcoef_InvQuadRootN24E03.dat"
#include "PFcoef_InvQuadRootN24E04.dat"
#include "PFcoef_InvQuadRootN24E05.dat"
#include "PFcoef_InvQuadRootN24E06.dat"
#include "PFcoef_InvQuadRootN24E07.dat"
#include "PFcoef_InvQuadRootN24E08.dat"
#include "PFcoef_InvQuadRootN25E01.dat"
#include "PFcoef_InvQuadRootN25E02.dat"
#include "PFcoef_InvQuadRootN25E03.dat"
#include "PFcoef_InvQuadRootN25E04.dat"
#include "PFcoef_InvQuadRootN25E05.dat"
#include "PFcoef_InvQuadRootN25E06.dat"
#include "PFcoef_InvQuadRootN25E07.dat"
#include "PFcoef_InvQuadRootN25E08.dat"
#include "PFcoef_InvQuadRootN26E01.dat"
#include "PFcoef_InvQuadRootN26E02.dat"
#include "PFcoef_InvQuadRootN26E03.dat"
#include "PFcoef_InvQuadRootN26E04.dat"
#include "PFcoef_InvQuadRootN26E05.dat"
#include "PFcoef_InvQuadRootN26E06.dat"
#include "PFcoef_InvQuadRootN26E07.dat"
#include "PFcoef_InvQuadRootN26E08.dat"
#include "PFcoef_InvQuadRootN27E01.dat"
#include "PFcoef_InvQuadRootN27E02.dat"
#include "PFcoef_InvQuadRootN27E03.dat"
#include "PFcoef_InvQuadRootN27E04.dat"
#include "PFcoef_InvQuadRootN27E05.dat"
#include "PFcoef_InvQuadRootN27E06.dat"
#include "PFcoef_InvQuadRootN27E07.dat"
#include "PFcoef_InvQuadRootN27E08.dat"
#include "PFcoef_InvQuadRootN28E01.dat"
#include "PFcoef_InvQuadRootN28E02.dat"
#include "PFcoef_InvQuadRootN28E03.dat"
#include "PFcoef_InvQuadRootN28E04.dat"
#include "PFcoef_InvQuadRootN28E05.dat"
#include "PFcoef_InvQuadRootN28E06.dat"
#include "PFcoef_InvQuadRootN28E07.dat"
#include "PFcoef_InvQuadRootN28E08.dat"
#include "PFcoef_InvQuadRootN29E01.dat"
#include "PFcoef_InvQuadRootN29E02.dat"
#include "PFcoef_InvQuadRootN29E03.dat"
#include "PFcoef_InvQuadRootN29E04.dat"
#include "PFcoef_InvQuadRootN29E05.dat"
#include "PFcoef_InvQuadRootN29E06.dat"
#include "PFcoef_InvQuadRootN29E07.dat"
#include "PFcoef_InvQuadRootN29E08.dat"
#include "PFcoef_InvQuadRootN30E01.dat"
#include "PFcoef_InvQuadRootN30E02.dat"
#include "PFcoef_InvQuadRootN30E03.dat"
#include "PFcoef_InvQuadRootN30E04.dat"
#include "PFcoef_InvQuadRootN30E05.dat"
#include "PFcoef_InvQuadRootN30E06.dat"
#include "PFcoef_InvQuadRootN30E07.dat"
#include "PFcoef_InvQuadRootN30E08.dat"
#include "PFcoef_InvQuadRootN31E01.dat"
#include "PFcoef_InvQuadRootN31E02.dat"
#include "PFcoef_InvQuadRootN31E03.dat"
#include "PFcoef_InvQuadRootN31E04.dat"
#include "PFcoef_InvQuadRootN31E05.dat"
#include "PFcoef_InvQuadRootN31E06.dat"
#include "PFcoef_InvQuadRootN31E07.dat"
#include "PFcoef_InvQuadRootN31E08.dat"
#include "PFcoef_InvQuadRootN32E01.dat"
#include "PFcoef_InvQuadRootN32E02.dat"
#include "PFcoef_InvQuadRootN32E03.dat"
#include "PFcoef_InvQuadRootN32E04.dat"
#include "PFcoef_InvQuadRootN32E05.dat"
#include "PFcoef_InvQuadRootN32E06.dat"
#include "PFcoef_InvQuadRootN32E07.dat"
#include "PFcoef_InvQuadRootN32E08.dat"
  m_is_initialized = .true.
  return
end subroutine

end module
